<?php

defined('ISHOP') or die('Access denied');

session_start();

// подключение модели
require_once MODEL;

// подключение библиотеки функций
require_once 'functions/functions.php';

// получение массива каталога
$cat = catalog(); 

// получение массива информеров
$informers = informer();

// регистрация
if($_POST['reg']){
    registration();
    redirect();
}

// авторизация
if($_POST['auth']){
    authorization();
    if($_SESSION['auth']['user']){
        // если пользователь авторизовался
        echo "<p>Добро пожаловать, {$_SESSION['auth']['user']}</p>";
        exit;
    }else{
        // если авторизация неудачна
        echo $_SESSION['auth']['error'];
        unset($_SESSION['auth']);
        exit;
    }
}

// выход пользователя
if($_GET['do'] == 'logout'){
    logout();
    redirect();
}

// получение динамичной части шаблона #content
$view = empty($_GET['view']) ? 'hits' : $_GET['view'];

switch($view){
    case('hits'):
        // лидеры продаж
        $eyestoppers = eyestopper('hits');
    break;
    
    case('new'):
        // новинки
        $eyestoppers = eyestopper('new');
    break;
    
    case('sale'):
        // распродажа
        $eyestoppers = eyestopper('sale');
    break;
    
    case('cat'):
        // товары категории
        $category = abs((int)$_GET['category']);
        
        // параметры для навигации
        $perpage = PERPAGE; // кол-во товаров на страницу
        if(isset($_GET['page'])){
            $page = (int)$_GET['page'];
            if($page < 1) $page = 1;
        }else{
            $page = 1;
        }
        $count_rows = count_rows($category); // общее кол-во товаров
        $pages_count = ceil($count_rows / $perpage); // кол-во страниц
        if(!$pages_count) $pages_count = 1; // минимум 1 страница
        if($page > $pages_count) $page = $pages_count; // если запрошенная страница больше максимума
        $start_pos = ($page - 1) * $perpage; // начальная позиция для запроса
        
        $products = products($category, $start_pos, $perpage); // получаем массив из модели
    break;
    
    case('addtocart'):
        // добавление в корзину
        $goods_id = abs((int)$_GET['goods_id']);
        addtocart($goods_id);
        
        $_SESSION['total_sum'] = total_sum($_SESSION['cart']);
        
        // кол-во товара в корзине + защита от ввода несуществующего ID товара
        total_quantity();
        redirect();
    break;
    
    case('cart'):
        /* корзина */
        // получение способов доставки
        $dostavka = get_dostavka();
        
        // пересчет товаров в корзине
        if(isset($_GET['id'], $_GET['qty'])){
            $goods_id = abs((int)$_GET['id']);
            $qty = abs((int)$_GET['qty']);
            
            $qty = $qty - $_SESSION['cart'][$goods_id]['qty'];
            addtocart($goods_id, $qty);
            
            $_SESSION['total_sum'] = total_sum($_SESSION['cart']); // сумма заказа
            
            total_quantity(); // кол-во товара в корзине + защита от ввода несуществующего ID товара
            redirect();
        }
        // удаление товара из корзины
        if(isset($_GET['delete'])){
            $id = abs((int)$_GET['delete']);
            if($id){
                delete_from_cart($id);
            }
            redirect();
        }
        
        if($_POST['order_x']){
            add_order();
            redirect();
        }
    break;
    
    case('reg'):
        // регистрация
    break;
    
    case('search'):
        // поиск
        $result_search = search();
        
        // параметры для навигации
        $perpage = 30; // кол-во товаров на страницу
        if(isset($_GET['page'])){
            $page = (int)$_GET['page'];
            if($page < 1) $page = 1;
        }else{
            $page = 1;
        }
        $count_rows = count($result_search); // общее кол-во товаров
        $pages_count = ceil($count_rows / $perpage); // кол-во страниц
        if(!$pages_count) $pages_count = 1; // минимум 1 страница
        if($page > $pages_count) $page = $pages_count; // если запрошенная страница больше максимума
        $start_pos = ($page - 1) * $perpage; // начальная позиция для запроса
        $endpos = $start_pos + $perpage; // до какого товара будет вывод на странице
        if($endpos > $count_rows) $endpos = $count_rows;
    break;
    
    case('filter'):
        // выбор по параметрам
        $startprice = (int)$_GET['startprice'];
        $endprice = (int)$_GET['endprice'];
        $brand = array();
        
        if($_GET['brand']){
            foreach($_GET['brand'] as $value){
                $value = (int)$value;
                $brand[$value] = $value;
            }
        }
        if($brand){
            $category = implode(',', $brand);
        }
        $products = filter($category, $startprice, $endprice);
    break;
    
    case('product'):
        // отдельный товар
        $goods_id = abs( (int)$_GET['goods_id'] );
        if($goods_id){
            $goods = get_goods($goods_id);
        }
    break;
  
    default:
        // если из адресной строки получено имя несуществующего вида
        $view = 'hits';
        $eyestoppers = eyestopper('hits');
}

// подключени вида
require_once TEMPLATE.'index.php';